{***************************************************************************
 *   Copyright 2006-2007 Antnio Galvo      antoniog12345@hotmail.com     *
 *                                                                         *
 *   This source is free software; you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This code is distributed in the hope that it will be useful, but      *
 *   WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   General Public License for more details.                              *
 *                                                                         *
 *   A copy of the GNU General Public License is available on the World    *
 *   Wide Web at <http://www.gnu.org/copyleft/gpl.html>. You can also      *
 *   obtain it by writing to the Free Software Foundation,                 *
 *   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.        *
 *                                                                         *
 ***************************************************************************}
                       {antoniog12345@hotmail.com}
unit DesafioDoCavaloUnit;

{$MODE Delphi}

interface

uses
  LCLIntf, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, LResources, Buttons, interfaces;

type

  { TfrmDesafioDoCavalo }

  TfrmDesafioDoCavalo = class(TForm)
    IniciarButton: TButton;
    Memo: TMemo;
    Panel1: TPanel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    procedure IniciarButtonClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MemoChange(Sender: TObject);
  private
    { Private declarations }
    procedure ExibeTabuleiro;
    procedure Tenta(X, Y :Integer);
    procedure DesenhaPosicao(flag, X, Y :Byte);
    procedure CriaBitmap;
    procedure PutBackBuffer;
    procedure appidle(sender:TObject;var done:Boolean);
    procedure AppException(Sender: TObject; E: Exception);
  public
    { Public declarations }
  end;


var
  frmDesafioDoCavalo: TfrmDesafioDoCavalo;

implementation


var
   Tabuleiro :array[0..7, 0..7] of Byte;
   Passo :Integer = 0;
   Inicio : TDateTime;
   S :string = '';
   SolucaoEncontrada :Boolean = False;
   Executando:Boolean = False;
   BackBuffer :TBitmap = nil;
   Encerrar :Boolean = False;

type
    TA = array[0..1]of Integer;

var
   Swap :TA;
   p1, p2 :Integer;

procedure TfrmDesafioDoCavalo.ExibeTabuleiro;
var
   X, Y :Integer;
begin
   for Y := 0 to 7 do
       for X := 0 to 7 do
       begin
           if Tabuleiro[X, Y] <> 0 then
              S := S +'  '+ Format('%.2d', [Tabuleiro[X, Y]]);
           if (X = 7)and(Y < 7) then S := S + #13#10;
       end;
   Memo.Lines.Add(S);
end;

procedure TfrmDesafioDoCavalo.Tenta(X, Y :Integer);
var
   i :Integer;
   Posicoes :array[0..7]of TA;
   //s :string;
begin
   //s := 'Desafio do Cavalo - C by Juci';
   application.processmessages;
   if Encerrar then Exit;
   if not assigned(BackBuffer) then Exit;
   
   if SolucaoEncontrada {then Exit;}
   or
   { se caiu fora do tabuleiro }
   {if} ( (x < 0)or(x > 7)or(y < 0)or(y > 7) ){then Exit;}
   or
   { ou se esta posicao ja foi visitada }
   {if} (Tabuleiro[X, Y] <> 0) then Exit;

   { anda um passo }
   Inc(Passo);

   { anota numero do passo no tabuleiro }
   Tabuleiro[x, y] := Passo;

       if assigned(BackBuffer) then
          DesenhaPosicao(1, X, Y);
    if assigned(BackBuffer) then
       PutBackBuffer;

   { se eh a ultima casa }
   if (Passo = {64}strtoint(edit1.text))then
    begin

      Memo.Lines.Add('Demorei '+
                           TimeToStr(time-Inicio) +
                           ' para encontrar esta soluo:'+
                           #13#10);


      //ExibeTabuleiro;

      SolucaoEncontrada := True;
      Exit;
    end;

   Posicoes[0][0] :=  1;
   Posicoes[0][1] :=  2;
   Posicoes[1][0] :=  2;
   Posicoes[1][1] :=  1;
   Posicoes[2][0] :=  2;
   Posicoes[2][1] := -1;
   Posicoes[3][0] :=  1;
   Posicoes[3][1] := -2;
   Posicoes[4][0] := -1;
   Posicoes[4][1] := -2;
   Posicoes[5][0] := -2;
   Posicoes[5][1] := -1;
   Posicoes[6][0] := -2;
   Posicoes[6][1] :=  1;
   Posicoes[7][0] := -1;
   Posicoes[7][1] :=  2;

   Randomize;
   for i := 0 to 7 do
   begin
      p1 := Random(8);
      p2 := Random(8);
      while (p1 = p2)or(p2 < -1)or(p2 > 7)do p2 := Random(8);
      Swap         := Posicoes[p1];
      Posicoes[p1] := Posicoes[p2];
      Posicoes[p2] := Swap;
   end;
//==============================================================================
       {
        ____Juci_____
        tenta(x+1,y+2);
        tenta(x+2,y+1);
        tenta(x+2,y-1);
        tenta(x+1,y-2);
        tenta(x-1,y-2);
        tenta(x-2,y-1);
        tenta(x-2,y+1);
        tenta(x-1,y+2);
        _______________
        }
    
   {A seqncia das tentativas no programa do Juci
    no  completamente aleatria, j que existe uma
    seqncia prefixada, como se v a em cima.
    A minha seqncia de tentativas procura ser
    completamente aleatria, sem repetir sempre um
    caminho que acabe forando uma soluo nica.
    Mas, pelo menos ao que me parece, o problema
    principal que ele visou foi a velocidade de
    execuo, que  muito maior que a do meu modesto
    programa.}
   Tenta(x+Posicoes[0][0],y+Posicoes[0][1]);
   Tenta(x+Posicoes[1][0],y+Posicoes[1][1]);
   Tenta(x+Posicoes[2][0],y+Posicoes[2][1]);
   Tenta(x+Posicoes[3][0],y+Posicoes[3][1]);
   Tenta(x+Posicoes[4][0],y+Posicoes[4][1]);
   Tenta(x+Posicoes[5][0],y+Posicoes[5][1]);
   Tenta(x+Posicoes[6][0],y+Posicoes[6][1]);
   Tenta(x+Posicoes[7][0],y+Posicoes[7][1]);
//==============================================================================

   { Apaga do tabuleiro a tentativa frustrada }
   Tabuleiro[X, Y] := 0;

   if not SolucaoEncontrada  then
      DesenhaPosicao(0, X, Y);

   { volta um passo }
   Dec(Passo);
end;

procedure TfrmDesafioDoCavalo.IniciarButtonClick(Sender: TObject);
{Esta  a Main em C.}
begin

   if Executando then
   begin
      encerrar := true;
      Application.ProcessMessages;
      Exit;
   end;

   FillChar(Tabuleiro, SizeOf(Tabuleiro), 0);
   
   Edit1.Enabled := False;
   UpDown1.Enabled := False;

   if iniciarbutton.caption = 'Concludo' then
   begin
      iniciarbutton.caption := 'Iniciar';
      Executando := False;
      SolucaoEncontrada := True;
      encerrar := true;
      Memo.lines.clear;
      Memo.Lines.Add('Desafio do Cavalo - C by Juci');
      Memo.Lines.Add(#13#10);

      Edit1.Enabled := True;
      UpDown1.Enabled := True;

      panel1.repaint;
      
      Exit;
   end;

   if  (IniciarButton.caption = 'Iniciar') then
   begin
   IniciarButton.Caption := 'Executando';
   Executando := True;
   Encerrar := False;
   SolucaoEncontrada := False;
   
   Memo.Lines.Clear;
   Memo.Lines.Add('Desafio do Cavalo - C by Juci');
   Memo.Lines.Add(#13#10);

   Application.ProcessMessages;
   Inicio := time;

   CriaBitmap;
   // A rotina recursiva
   Tenta(0,0);
   IniciarButton.Caption := 'Concludo';

   if not SolucaoEncontrada then
      if Encerrar then

      else
         Memo.Lines.Add('Nao fui capaz de encontrar a solucao');

   Executando := False;
   Passo := 0;
   Inicio := 0;
   S := '';
   FillChar(Tabuleiro, SizeOf(Tabuleiro), 0);

   Edit1.Enabled := True;
   UpDown1.Enabled := True;

   end;
end;

procedure TfrmDesafioDoCavalo.CriaBitmap;
begin
   BackBuffer := TBitmap.Create;
   with BackBuffer do begin
     Height := panel1.height;
     Width := panel1.width;
     with canvas do begin
       brush.color := panel1.color;
       pen.color := panel1.color;
       rectangle(0, 0, BackBuffer.Width, BackBuffer.Height);
     end;
   end;
end;

procedure TfrmDesafioDoCavalo.DesenhaPosicao(flag, X, Y :Byte);
begin
     if not assigned(BackBuffer) then Exit; // essa chamada s funcionou
                                            // depois de liberado o BackBuffer
                                            // e igualado a nil.
                                            // Liberar (Free) no bastou.

     with BackBuffer.canvas do begin
       font := Panel1.font;
       if flag = 1 then begin
          brush.style := bssolid;
          brush.color := clyellow;
          pen.color := clblack;
       end
       else begin
          brush.style := bssolid;
          pen.color := clbtnshadow;
          brush.color := clbtnshadow;
          font.color := clbtnshadow;
       end;

     Rectangle( (x)*20,
                (Y)*20,
                (x)*20+18,
                (Y)*20+18 );

     if flag = 1 then
        begin
            brush.style := bsclear;
            textout(x*20+10-textwidth(inttostr(tabuleiro[x,y]))div 2,
                     y*20+10-textheight(inttostr(tabuleiro[x,y]))div 2,
                     inttostr(tabuleiro[x,y]));
        end
        else
        begin
        end;
     end;
end;

procedure TfrmDesafioDoCavalo.PutBackBuffer;
var
   CtrlCanvas: TControlCanvas;
begin
   if not assigned(backbuffer) then exit;

   CtrlCanvas := TControlCanvas.Create;
   with CtrlCanvas do
   begin
     Control := Panel1;
     Draw(0, 0, BackBuffer);
     Free;
   end;
end;

procedure TfrmDesafioDoCavalo.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   Encerrar := True;
   application.processmessages;
   BackBuffer.Free;
   BackBuffer := nil;
   application.processmessages;
end;

procedure TfrmDesafioDoCavalo.appidle(sender:TObject;var done:Boolean);
begin
   if assigned(backbuffer) and (not encerrar) then
      PutBackBuffer;
end;

procedure TfrmDesafioDoCavalo.AppException(Sender: TObject; E: Exception);
begin
  application.terminate;
end;

procedure TfrmDesafioDoCavalo.FormCreate(Sender: TObject);
begin
  ShortTimeFormat := 'hh:nn:ss';
  application.onidle := appidle;
end;

procedure TfrmDesafioDoCavalo.Edit1Change(Sender: TObject);
begin
   if (strtoint(edit1.text) > 64)
      or (strtoint(edit1.text) <= 0) then edit1.text := '64';
end;

procedure TfrmDesafioDoCavalo.Edit1KeyPress(Sender: TObject;
  var Key: Char);
begin
   if not (key in [Char('0')..Char('9')]) then
      key := #0;
end;

procedure TfrmDesafioDoCavalo.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
{
   if (key = vk_return) then
      IniciarButtonClick(Sender);
}
end;

procedure TfrmDesafioDoCavalo.MemoChange(Sender: TObject);
begin

end;

initialization
  {$i DesafioDoCavaloUnit.lrs}

end.
{   A Soluo:
    Salvo melhor juzo,
    s existe esta.

01 60 39 34 31 18 09 64
38 35 32 61 10 63 30 17
59 02 37 40 33 28 19 08
36 49 42 27 62 11 16 29
43 58 03 50 41 24 07 20
48 51 46 55 26 21 12 15
57 44 53 04 23 14 25 06
52 47 56 45 54 05 22 13

}
